local GH = GarrisonHelper
-- Frame and Events
local GarrisonHelper_Events = CreateFrame("Frame");
local events = {};
-- IDs
local kristenStoneforge = 77377;
local grunlek = 79815;
ironHordeScraps = 113681;
scrapMeltdownA = 38175;
scrapMeltdownH = 38188;
local armoryID = 10; -- war mill / bunker

function GH:isNeededNPC()
	return GH:isArmoryEnabled() and (GH:isNPC(kristenStoneforge) or GH:isNPC(grunlek)); 
end
function GH:isNeededQuest()
	return GetQuestID()==scrapMeltdownA or GetQuestID()==scrapMeltdownH; 
end
function GH:isArmoryEnabled()
	if type(GH.db.profile.bunkersupport)==nil then GH.db.profile.bunkersupport=true end
	return GH.db.profile.bunkersupport
end

function events.GOSSIP_SHOW()
	if GH:isNeededNPC() and GH:hasBuilding(armoryID,3) then 
		if GetNumGossipAvailableQuests()==1 then
			if GetItemCount(ironHordeScraps, true)>=25 then 	
				SelectGossipAvailableQuest(1);
			else
				print("|r|cFFFF7700<GarrisonHelper>|r|cFFFFFFFF Not enough \124cffffffff\124Hitem:113681:0:0:0:0:0:0:0:0:0:0\124h[Iron Horde Scraps]\124h\124r");
			end
		end
		if GetNumGossipActiveQuests()==1 and GetItemCount(ironHordeScraps, true)>=25 then
			SelectGossipActiveQuest(1);
		end
	end
end

function events.QUEST_DETAIL()
	if GH:isNeededQuest() and GetItemCount(ironHordeScraps, true)>=25 then 
		AcceptQuest();
	end
end

function events.QUEST_COMPLETE()
	if GH:isNeededQuest() and GetItemCount(ironHordeScraps, true)>=25 then 
		GH.db.profile.bunkertoken = GH.db.profile.bunkertoken or "smart"
		local o = 4
		if GH.db.profile.bunkertoken == "smart" then
			o = 4
		elseif GH.db.profile.bunkertoken == "random" then
			o = 3
		elseif GH.db.profile.bunkertoken == "weapon" then
			o = 2
		elseif GH.db.profile.bunkertoken == "armor" then
			o = 1
		end
		
		if o==3 then
			if math.random()>0.5 then o=1 else o=2 end
		elseif o==4 then
			o = GH:smartTokenChoice()
		end
		GetQuestReward(o);
	end
end

function GH:smartTokenChoice()
		local o = 1
		local weaponCount = 3*GetItemCount(114128, true)+6*GetItemCount(114131, true)+9*GetItemCount(114129, true);
		local armorCount = 3*GetItemCount(114745, true)+6*GetItemCount(114808, true)+9*GetItemCount(114822, true);
		if weaponCount > armorCount then o=1 else o=2 end
		return o, weaponCount, armorCount
end

function events.QUEST_PROGRESS()
	if GH:isNeededQuest() and GetItemCount(ironHordeScraps, true)>=25 then
		if IsQuestCompletable() then CompleteQuest() end 
	end
end

function GH_armoryWelcome()
	if GH:isArmoryEnabled() and GH:hasBuilding(armoryID,3) then
		local q = scrapMeltdownH;
		if UnitFactionGroup("player")=="Alliance" then
			q = scrapMeltdownA;
		end
		
		if not IsQuestFlaggedCompleted(q) then
			local s= "";
			if GetItemCount(ironHordeScraps, true)<25 then
				s = s .. " (note: "..GetItemCount(ironHordeScraps, true).."/25 \124cffffffff\124Hitem:113681:0:0:0:0:0:0:0:0:0:0\124h[Iron Horde Scraps]\124h\124r)"
			end
			print("|r|cFFFF7700<GarrisonHelper>|r|cFFFFFFFF \124cffffff00\124Hquest:" .. q .. ":-1\124h[Scrap Meltdown]\124h\124r not completed today"..s);
		end
	end
end

-- register event listener
GarrisonHelper_Events:SetScript("OnEvent", function(self, event, ...) events[event](self, event, ...); end);
for event, func in pairs(events) do GarrisonHelper_Events:RegisterEvent(event); end

