-- local ADDON, data = ...
local _G = _G
local GH = GarrisonHelper
GH.LS = LibStub
--GH.L = GH.LS("AceLocale-3.0"):GetLocale("GarrisonHelper")
--GH.AIS = GH.LS("LibAdvancedIconSelector-MTK")
GH.LDB = GH.LS("LibDataBroker-1.1")
GH.slash = string.sub(_G.SLASH_CAST1, 1, 1)
GH.click = _G.SLASH_CLICK1
GH.target = _G.SLASH_TARGET1
local AceConfig = GH.LS("AceConfig-3.0")
local AceConfigDialog = GH.LS("AceConfigDialog-3.0")
local AceDBOptions = GH.LS("AceDBOptions-3.0")
--local LSM = GH.LS("LibSharedMedia-3.0")
--local L = GH.L
	
-- Init and set variables --
function GarrisonHelper_ConfigInit()
	GH.db = GH.LS("AceDB-3.0"):New("GarrisonHelperDB", GH.defaults, "profile")
	
	SlashCmdList["GARRISONHELPER"] = function(msg)
		GH.db.profile.wasconfigured = GH.db.profile.wasconfigured or time() -- once slash command was used, the "\gh" message will not appear again
		InterfaceOptionsFrame:Show()
		InterfaceOptionsFrameTab2:Click()
		local searchSub = false
		local i = 1
		local currAddon = "InterfaceOptionsFrameAddOnsButton" .. i
		while _G[currAddon] do
			
			if (_G[currAddon]:GetText() == "GarrisonHelper") then
				_G[currAddon .. "Toggle"]:Click() -- press [+] button
				searchSub = true
			end
			if searchSub and (_G[currAddon]:GetText() == "Configuration") then
				_G[currAddon]:Click()
				break
			end
			i = i + 1
			currAddon = "InterfaceOptionsFrameAddOnsButton" .. i
		end
	end
	SLASH_GARRISONHELPER1 = "/garrisonhelper"
	SLASH_GARRISONHELPER2 = "/gh"	
	
	GH:CreateOptions()
	GH:DefaultValues()
end

function GH:DefaultValues()
	GH:set("jewelcraftingquest1id",37321)
	GH:set("jewelcraftingquest2id",37323)
	GH:set("jewelcraftingquest3id",37319) 
	GH:set("jewelcraftingquest4id",37320)
	GH:set("jewelcraftingquest5id",37324)
	GH:set("jewelcraftingquest6id",37325)
	GH:set("jewelcraftingquest1",true)
	GH:set("jewelcraftingquest2",true)
	GH:set("jewelcraftingquest3",true) 
	GH:set("jewelcraftingquest4",true)
	GH:set("jewelcraftingquest5",true)
	GH:set("jewelcraftingquest6",true)
	GH:set("bunkersupport",true)
	GH:set("bunkertoken","smart")
	GH:set("scribesupport",true)
	GH:set("jewelcraftingsupport",true)
	GH:set("tradingpostsupport",true)
	GH:set("tradingpostoption","icons")
	GH:set("workorderssupport",false)
	GH:set("workordersbuildingenabled",{})
	GH:set("workorderstradegood",{})
end

function GH:set(var,default)
	if type(GH.db.profile[var])=="nil" then
		GH.db.profile[var] = default
	end
end

function GH_GetItemIcon(id)
	local icon = GetItemIcon(id);
	--[[
	icon.width = 10
 	icon.height = 10
	
	local icon = _G["AceGUI30Button" .. i ]:CreateTexture(nil, "OVERLAY")
	icon:SetAllPoints(true)
	icon:SetTexture(GetItemIcon(109128))
	icon.width=30
	icon.height=30
	]]
	return icon
end

GH.interfacePanel = {
	order = 4,
	type = "group",
	name = "Dailies",
	childGroups = "tab",
	args = {
		armorytab = {
			order = 1,
			type = "group",
			name = "Dwarven Bunker / War Mill",
			args = {
				note1 = {
					order = 0,
					type = "description",
					fontSize = "medium",
					name = format("\n%s\n", "This support auto-accepts and completes the Dwarven Bunker / War Mill daily."),
				},
				enablesupport = {
					order = 1,
					type = "toggle",
					name = "Enable support",
					width = "full",
					get = function() return GH.db.profile.bunkersupport end,
					set = function(info, value) GH.db.profile.bunkersupport = value end,
				},
				bunkersupport = {
					order = 2,
					type = "group",
					inline = true,
					hidden =  function() return not GH.db.profile.bunkersupport end,
					name = " ",
					args = {
						note2 = {
							order = 0,
							type = "description",
							fontSize = "medium",
							name = format("\n%s:\n", "Choose Dwarven Bunker/War Mill daily quest reward"),
						},
						select = {
							order = 1,
							type = "select",
							style = "dropdown",
							name = "Token",
							values = {armor = "Armor Token", weapon = "Weapon Token", random = "Choose a random token as reward.", smart = "Choose the token which you have less. (default)"},
							width = "full",
							get = function() return GH.db.profile.bunkertoken end,
							set = function(info, value) GH.db.profile.bunkertoken = value; end,
						},
					},
				},
			},
		},
		scribetab = {
			order = 2,
			type = "group",
			name = "Scribe daily",
			args = {
				note1 = {
					order = 0,
					type = "description",
					fontSize = "medium",
					name = format("\n%s\n", "This support assists in the creation of Draenor Merchant Orders by the NPC in the Scribe Building."),
				},
				enablesupport = {
					order = 1,
					type = "toggle",
					name = "Enable support",
					width = "full",
					get = function() return GH.db.profile.scribesupport end,
					set = function(info, value) GH.db.profile.scribesupport = value end,
				},
				scribesupport = {
					order = 2,
					type = "group",
					inline = true,
					hidden =  function() return not GH.db.profile.scribesupport end,
					name = " ",
					args = {
						note2 = {
							order = 0,
							type = "description",
							fontSize = "small",
							name = "When right clicking the NPC, an action button will appear at the mouse pointer. Dependent on the number of Cerulean Pigment this action button will mill herbs or create Draenor Merchant Orders. In the worst case, you have to press this button three times, to mill, mill again and then create Draenor Merchant Orders.\nShort: Right click NPC until Draenor Merchant Orders drop.",
						},
						note3 = {
							order = 1,
							type = "description",
							fontSize = "medium",
							name = format("\n%s\n%s:", "Please rank this list of herbs. Milling herbs will be done by this priority.","(<left click> to raise priority, <right click> to lower the priority)"),
						},
						herborder = {
							order = 2,
							type = "group",
							--inline = false,
							name = " ",
							width = "half",
							args = {
								herb1 = {
									order = 0,
									--name = "\124T".. GH_GetItemIcon(109125) ..":24\124t" .. "Fireweed",
									name = "109125",
									type = "execute",
									width = "half",
									func = function(arg1, arg2)GH:reorderHerbs(arg1, arg2)end,
								},
								herb2 = {
									order = 1,
									type = "execute",
									--name = "\124T".. GH_GetItemIcon(109124) ..":24\124t" .. "Frostweed",
									name = "109124",
									width = "half",
									func = function(arg1, arg2)GH:reorderHerbs(arg1, arg2)end,
								},
								herb3 = {
									order = 2,
									type = "execute",
									--name = "\124T"..GH_GetItemIcon(109126) ..":24\124t" .. "Gorgrond Flytrap",
									name = "109126",
									width = "half",
									func = function(arg1, arg2)GH:reorderHerbs(arg1, arg2)end,
								},
								herb4 = {
									order = 3,
									type = "execute",
									--name = "\124T".. GH_GetItemIcon(109128) ..":24\124t" .. "Nagrand Arrowbloom",
									name = "109128",
									width = "half",
									func = function(arg1, arg2)GH:reorderHerbs(arg1, arg2)end,
								},
								herb5 = {
									order = 4,
									type = "execute",
									--name = "\124T".. GH_GetItemIcon(109127) ..":24\124t" .. "Starflower",
									name = "109127",
									width = "half",
									func = function(arg1, arg2)GH:reorderHerbs(arg1, arg2)end,
								},
								herb6 = {
									order = 5,
									type = "execute",
									--name = "\124T".. GH_GetItemIcon(109129) ..":24\124t" .. "Talador Orchid",
									name = "109129",
									width = "half",
									func = function(arg1, arg2)GH:reorderHerbs(arg1, arg2)end,
								},
								note = {
									order = -3,
									type = "description",
									fontSize = "medium",
									name = format("\n\n\n%s:", "If you like to have a milling macro, using this priority"),
								},
								macroborder = {
									order = -2,
									type = "group",
									inline = true,
									name = " ",
									args = {
										macro = {
											order = 1,
											type = "description",
											fontSize = "normal",
											name = format("%s\n%s\n%s", "#showtooltip Milling","/run MillingMacro()","/click GH_Button"),
										},
									}
								},
								callbackHandler = {
									-- misused to set callbacks, because it is called after buttons are set
									order = -1,
									type = "description",
								--	hidden = true,
									name = function()
										GH:RegisterButtons()
										return "" 
									end,
								},
							},
						},
					},
				},
			},
		},
		jewelcraftingtab = {
			order = 3,
			type = "group",
			name = "Jewelcrafting daily",
			args = {
				note1 = {
					order = 0,
					type = "description",
					fontSize = "medium",
					name = format("\n%s\n", "This support auto-accepts and completes the Jewelcrafting building daily"),
				},
				enablesupport = {
					order = 1,
					type = "toggle",
					name = "Enable support",
					width = "full",
					get = function() return GH.db.profile.jewelcraftingsupport end,
					set = function(info, value) GH.db.profile.jewelcraftingsupport = value end,
				},
				jewelcraftingsupport = {
					order = 2,
					type = "group",
					inline = true,
					hidden =  function() return not GH.db.profile.jewelcraftingsupport end,
					name = " ",
					args = {
						note2 = {
							order = 0,
							type = "description",
							fontSize = "small",
							name = "When right clicking the NPC, the belonging daily quest will be accepted, if it can be completed. Dependent on the daily quest the next right click completes the quest or an action button will appear at the mouse pointer. Use this action button to craft the quest objective. \nShort: Right click NPC until Jewelcrafting Payment drops.",
						},
						note3 = {
							order = 1,
							type = "description",
							fontSize = "medium",
							name = format("\n%s:", "The Jewelcrafting Payment is worth a lot. However, feel free to deselect unprofitable dailies (represented by required resources)"),
						},
						dailies = {
							order = 2,
							type = "group",
							--inline = false,
							name = " ",
							width = "half",
							args = {
								quest1 = {
									order = 0,
									type = "toggle",
									name = function() return GH:JewelcraftingQuestResources(37321) end,
									desc = function() return GH:JewelcraftingQuestTooltip(37321) end,
									width = "full",
									get = function() return GH.db.profile.jewelcraftingquest1 end,
									set = function(info, value) GH.db.profile.jewelcraftingquest1 = value end,
								},
								quest2 = {
									order = 1,
									type = "toggle",
									name =function() return GH:JewelcraftingQuestResources(37323) end,
									desc = function() return GH:JewelcraftingQuestTooltip(37323) end,
									width = "full",
									get = function() return GH.db.profile.jewelcraftingquest2 end,
									set = function(info, value) GH.db.profile.jewelcraftingquest2 = value end,
								},
								quest3 = {
									order = 2,
									type = "toggle",
									name =function() return GH:JewelcraftingQuestResources(37319) end,
									desc = function() return GH:JewelcraftingQuestTooltip(37319) end,
									width = "full",
									get = function() return GH.db.profile.jewelcraftingquest3 end,
									set = function(info, value) GH.db.profile.jewelcraftingquest3 = value end,
								},
								quest4 = {
									order = 3,
									type = "toggle",
									name =function() return GH:JewelcraftingQuestResources(37320) end,
									desc = function() return GH:JewelcraftingQuestTooltip(37320) end,
									width = "full",
									get = function() return GH.db.profile.jewelcraftingquest4 end,
									set = function(info, value) GH.db.profile.jewelcraftingquest4 = value end,
								},
								quest5 = {
									order = 4,
									type = "toggle",
									name =function() return GH:JewelcraftingQuestResources(37324) end,
									desc = function() return GH:JewelcraftingQuestTooltip(37324) end,
									width = "full",
									get = function() return GH.db.profile.jewelcraftingquest5 end,
									set = function(info, value) GH.db.profile.jewelcraftingquest5 = value end,
								},
								quest6 = {
									order = 5,
									type = "toggle",
									name = function() return GH:JewelcraftingQuestResources(37325) end,
									desc = function() return GH:JewelcraftingQuestTooltip(37325) end,
									width = "full",
									get = function() return GH.db.profile.jewelcraftingquest6 end,
									set = function(info, value) GH.db.profile.jewelcraftingquest6 = value end,
								},
							},
						},
					},
				},
			},
		},
		tradingposttab = {
			order = 3,
			type = "group",
			name = "Traiding Post Trader",
			args = {
				note1 = {
					order = 0,
					type = "description",
					fontSize = "medium",
					name = format("\n%s\n", "The Traiding Post trader changes everyday. Each trader has special trading goods he sells for 4 Garrison Resources. Mouseover the trader NPC and you will see what's on sale."),
				},
				note2 = {
					order = 1,
					type = "description",
					fontSize = "small",
					name = "(Note, that there is a timeout of 5 minutes between each listing of items, to avoid spamming.)",
				},
				enablesupport = {
					order = 2,
					type = "toggle",
					name = "Enable support",
					width = "full",
					get = function() return GH.db.profile.tradingpostsupport end,
					set = function(info, value) GH.db.profile.tradingpostsupport = value  for id, arr in pairs(GH.npcMessages) do arr[4]=nil end  end,
				},
				tradingpostsupport = {
					order = 3,
					type = "group",
					inline = true,
					hidden =  function() return not GH.db.profile.tradingpostsupport end,
					name = " ",
					args = {
						select = {
							order = 1,
							type = "select",
							style = "dropdown",
							name = "Choose how to print out items on sale",
							values = {icons = "Use small icons (default)", short = "Write a small summary of item types (e.g. Leather & Fish)", links = "Use clickable item links"},
							width = "full",
							get = function() return GH.db.profile.tradingpostoption end,
							set = function(info, value) GH.db.profile.tradingpostoption = value; for id, arr in pairs(GH.npcMessages) do arr[4]=nil end end,
						},
					},
				},
			},
		},
		workorderstab = {
			order = 4,
			type = "group",
			name = "Work Orders",
			args = {
				note1 = {
					order = 0,
					type = "description",
					fontSize = "medium",
					name = format("\n%s\n", "Automatically clicks the [Complete All] button for work orders.\n(I know that this is done by several other addons, but was requested by a friend.)"),
				},
				enablesupport = {
					order = 1,
					type = "toggle",
					name = "Enable support",
					width = "full",
					get = function() return GH.db.profile.workorderssupport end,
					set = function(info, value) GH.db.profile.workorderssupport = value end,
				},
				workorderssupport = {
					order = 2,
					type = "group",
					inline = true,
					hidden =  function() return not GH.db.profile.workorderssupport end,
					name = " ",
					args = {
						note1 = {
							order = 1,
							type = "description",
							fontSize = "medium",
							name = format("\n%s:",  "Choose building to allow auto complete all work orders"),
						},
						buildings = {
							order = 2,
							type = "group",
							name = " ",
							width = "half",
							args = {
								building1 = {
									order = 0,
									type = "toggle",
									name = function() return GH:WorkOrdersBuilding(76) end,
									desc = function() return GH:WorkOrdersBuildingTooltip(76) end,
									width = "full",
									get = function() return GH.db.profile.workordersbuildingenabled[76] end,
									set = function(info, value) GH.db.profile.workordersbuildingenabled[76] = value end,
								},
								building2 = {
									order = 1,
									type = "toggle",
									name = function() return GH:WorkOrdersBuilding(93) end,
									desc = function() return GH:WorkOrdersBuildingTooltip(93) end,
									width = "full",
									get = function() return GH.db.profile.workordersbuildingenabled[93] end,
									set = function(info, value) GH.db.profile.workordersbuildingenabled[93] = value end,
								},
								building3 = {
									order = 2,
									type = "toggle",
									name = function() return GH:WorkOrdersBuilding(91) end,
									desc = function() return GH:WorkOrdersBuildingTooltip(91) end,
									width = "full",
									get = function() return GH.db.profile.workordersbuildingenabled[91] end,
									set = function(info, value) GH.db.profile.workordersbuildingenabled[91] = value end,
								},
								building4 = {
									order = 3,
									type = "toggle",
									name = function() return GH:WorkOrdersBuilding(96) end,
									desc = function() return GH:WorkOrdersBuildingTooltip(96) end,
									width = "full",
									get = function() return GH.db.profile.workordersbuildingenabled[96] end,
									set = function(info, value) GH.db.profile.workordersbuildingenabled[96] = value end,
								},
								building5 = {
									order = 4,
									type = "toggle",
									name = function() return GH:WorkOrdersBuilding(95) end,
									desc = function() return GH:WorkOrdersBuildingTooltip(95) end,
									width = "full",
									get = function() return GH.db.profile.workordersbuildingenabled[95] end,
									set = function(info, value) GH.db.profile.workordersbuildingenabled[95] = value end,
								},
								building6 = {
									order = 5,
									type = "toggle",
									name = function() return GH:WorkOrdersBuilding(94) end,
									desc = function() return GH:WorkOrdersBuildingTooltip(94) end,
									width = "full",
									get = function() return GH.db.profile.workordersbuildingenabled[94] end,
									set = function(info, value) GH.db.profile.workordersbuildingenabled[94] = value end,
								},
								building7 = {
									order = 6,
									type = "toggle",
									name = function() return GH:WorkOrdersBuilding(60) end,
									desc = function() return GH:WorkOrdersBuildingTooltip(60) end,
									width = "full",
									get = function() return GH.db.profile.workordersbuildingenabled[60] end,
									set = function(info, value) GH.db.profile.workordersbuildingenabled[60] = value end,
								},
								building8 = {
									order = 7,
									type = "toggle",
									name = function() return GH:WorkOrdersBuilding(90) end,
									desc = function() return GH:WorkOrdersBuildingTooltip(90) end,
									width = "full",
									get = function() return GH.db.profile.workordersbuildingenabled[90] end,
									set = function(info, value) GH.db.profile.workordersbuildingenabled[90] = value end,
								},	
								building9 = {
									order = 8,
									type = "toggle",
									name = function() return GH:WorkOrdersBuilding(24) end,
									desc = function() return GH:WorkOrdersBuildingTooltip(24) end,
									width = "full",
									get = function() return GH.db.profile.workordersbuildingenabled[24] end,
									set = function(info, value) GH.db.profile.workordersbuildingenabled[24] = value end,
								},
								building10 = {
									order = 9,
									type = "toggle",
									name = function() return GH:WorkOrdersBuilding(159) end,
									desc = function() return GH:WorkOrdersBuildingTooltip(159) end,
									width = "full",
									get = function() return GH.db.profile.workordersbuildingenabled[159] end,
									set = function(info, value) GH.db.profile.workordersbuildingenabled[159] = value end,
								},
								building11 = {
									order = 10,
									type = "toggle",
									name = function() return GH:WorkOrdersBuilding(40) end,
									desc = function() return GH:WorkOrdersBuildingTooltip(40) end,
									width = "full",
									get = function() return GH.db.profile.workordersbuildingenabled[40] end,
									set = function(info, value) GH.db.profile.workordersbuildingenabled[40] = value end,
								},
								building13 = {
									order = 13,
									type = "toggle",
									name = function() return GH:WorkOrdersBuilding(8) end,
									desc = function() return GH:WorkOrdersBuildingTooltip(8) end,
									width = "full",
									get = function() return GH.db.profile.workordersbuildingenabled[8] end,
									set = function(info, value) GH.db.profile.workordersbuildingenabled[8] = value end,
								},
								building14 = {
									order = 14,
									type = "toggle",
									name = function() return GH:WorkOrdersBuilding(37) end,
									desc = function() return GH:WorkOrdersBuildingTooltip(37) end,
									width = "full",
									get = function() return GH.db.profile.workordersbuildingenabled[37] end,
									set = function(info, value) GH.db.profile.workordersbuildingenabled[37] = value end,
								},
								building15 = {
									order = 15,
									type = "toggle",
									name = function() return GH:WorkOrdersBuilding(29) end,
									desc = function() return GH:WorkOrdersBuildingTooltip(29) end,
									width = "full",
									get = function() return GH.db.profile.workordersbuildingenabled[29] end,
									set = function(info, value) GH.db.profile.workordersbuildingenabled[29] = value end,
								},
								building16 = {
									order = 16,
									type = "toggle",
									name = function() return GH:WorkOrdersBuilding(61) end,
									desc = function() return GH:WorkOrdersBuildingTooltip(61) end,
									width = "full",
									get = function() return GH.db.profile.workordersbuildingenabled[61] end,
									set = function(info, value) GH.db.profile.workordersbuildingenabled[61] = value end,
								},
								building12 = {--trading post
									order = 17,
									type = "toggle",
									name = function() return GH:WorkOrdersBuilding(111) end,
									desc = function() return GH:WorkOrdersBuildingTooltip(111) end,
									width = "full",
									get = function() return GH.db.profile.workordersbuildingenabled[111] end,
									set = function(info, value) GH.db.profile.workordersbuildingenabled[111] = value end,
								},
								tradingpost = {
									order = 18,
									type = "group",
									name = "Select trade goods allowed to use:",
									hidden =  function() return not GH.db.profile.workordersbuildingenabled[111] end,
									width = "half",
									args = {
										tradegood1 = {
											order = 0,
											type = "toggle",
											name = function() return GH:WorkOrdersTradegood(109128) end,
											desc = function() return GH:WorkOrdersTradegoodTooltip(109128) end,
											width = "full",
											get = function() return GH.db.profile.workorderstradegood[109128] end,
											set = function(info, value) GH.db.profile.workorderstradegood[109128] = value end,
										},
										tradegood2 = {
											order = 1,
											type = "toggle",
											name = function() return GH:WorkOrdersTradegood(109125) end,
											desc = function() return GH:WorkOrdersTradegoodTooltip(109125) end,
											width = "full",
											get = function() return GH.db.profile.workorderstradegood[109125] end,
											set = function(info, value) GH.db.profile.workorderstradegood[109125] = value end,
										},
										tradegood3 = {
											order = 2,
											type = "toggle",
											name = function() return GH:WorkOrdersTradegood(109129) end,
											desc = function() return GH:WorkOrdersTradegoodTooltip(109129) end,
											width = "full",
											get = function() return GH.db.profile.workorderstradegood[109129] end,
											set = function(info, value) GH.db.profile.workorderstradegood[109129] = value end,
										},
										tradegood4 = {
											order = 3,
											type = "toggle",
											name = function() return GH:WorkOrdersTradegood(109126) end,
											desc = function() return GH:WorkOrdersTradegoodTooltip(109126) end,
											width = "full",
											get = function() return GH.db.profile.workorderstradegood[109126] end,
											set = function(info, value) GH.db.profile.workorderstradegood[109126] = value end,
										},
										tradegood5 = {
											order = 4,
											type = "toggle",
											name = function() return GH:WorkOrdersTradegood(109124) end,
											desc = function() return GH:WorkOrdersTradegoodTooltip(109124) end,
											width = "full",
											get = function() return GH.db.profile.workorderstradegood[109124] end,
											set = function(info, value) GH.db.profile.workorderstradegood[109124] = value end,
										},
										tradegood6 = {
											order = 5,
											type = "toggle",
											name = function() return GH:WorkOrdersTradegood(109127) end,
											desc = function() return GH:WorkOrdersTradegoodTooltip(109127) end,
											width = "full",
											get = function() return GH.db.profile.workorderstradegood[109127] end,
											set = function(info, value) GH.db.profile.workorderstradegood[109127] = value end,
										},
										tradegood7 = {
											order = 6,
											type = "toggle",
											name = function() return GH:WorkOrdersTradegood(109119) end,
											desc = function() return GH:WorkOrdersTradegoodTooltip(109119) end,
											width = "full",
											get = function() return GH.db.profile.workorderstradegood[109119] end,
											set = function(info, value) GH.db.profile.workorderstradegood[109119] = value end,
										},
										tradegood8 = {
											order = 7,
											type = "toggle",
											name = function() return GH:WorkOrdersTradegood(109118) end,
											desc = function() return GH:WorkOrdersTradegoodTooltip(109118) end,
											width = "full",
											get = function() return GH.db.profile.workorderstradegood[109118] end,
											set = function(info, value) GH.db.profile.workorderstradegood[109118] = value end,
										},
										tradegood9 = {
											order = 8,
											type = "toggle",
											name = function() return GH:WorkOrdersTradegood(110609) end,
											desc = function() return GH:WorkOrdersTradegoodTooltip(110609) end,
											width = "full",
											get = function() return GH.db.profile.workorderstradegood[110609] end,
											set = function(info, value) GH.db.profile.workorderstradegood[110609] = value end,
										},
										tradegood10 = {
											order = 9,
											type = "toggle",
											name = function() return GH:WorkOrdersTradegood(111557) end,
											desc = function() return GH:WorkOrdersTradegoodTooltip(111557) end,
											width = "full",
											get = function() return GH.db.profile.workorderstradegood[111557] end,
											set = function(info, value) GH.db.profile.workorderstradegood[111557] = value end,
										},
										tradegood11 = {
											order = 10,
											type = "toggle",
											name = function() return GH:WorkOrdersTradegood(109693) end,
											desc = function() return GH:WorkOrdersTradegoodTooltip(109693) end,
											width = "full",
											get = function() return GH.db.profile.workorderstradegood[109693] end,
											set = function(info, value) GH.db.profile.workorderstradegood[109693] = value end,
										},
										--TODO go on with meat and flesh: http://www.wowhead.com/npc=86777/elder-surehide
										--[[
										tradegood12 = {
											order = 11,
											type = "toggle",
											name = function() return GH:WorkOrdersTradegood(109131) end,
											desc = function() return GH:WorkOrdersTradegoodTooltip(109131) end,
											width = "full",
											get = function() return GH.db.profile.workorderstradegood[109131] end,
											set = function(info, value) GH.db.profile.workorderstradegood[109131] = value end,
										},
										tradegood13 = {
											order = 12,
											type = "toggle",
											name = function() return GH:WorkOrdersTradegood(109132) end,
											desc = function() return GH:WorkOrdersTradegoodTooltip(109132) end,
											width = "full",
											get = function() return GH.db.profile.workorderstradegood[109132] end,
											set = function(info, value) GH.db.profile.workorderstradegood[109132] = value end,
										},
										tradegood14 = {
											order = 13,
											type = "toggle",
											name = function() return GH:WorkOrdersTradegood(109133) end,
											desc = function() return GH:WorkOrdersTradegoodTooltip(109133) end,
											width = "full",
											get = function() return GH.db.profile.workorderstradegood[109133] end,
											set = function(info, value) GH.db.profile.workorderstradegood[109133] = value end,
										},
										tradegood15 = {
											order = 14,
											type = "toggle",
											name = function() return GH:WorkOrdersTradegood(109134) end,
											desc = function() return GH:WorkOrdersTradegoodTooltip(109134) end,
											width = "full",
											get = function() return GH.db.profile.workorderstradegood[109134] end,
											set = function(info, value) GH.db.profile.workorderstradegood[109134] = value end,
										},
										tradegood16 = {
											order = 15,
											type = "toggle",
											name = function() return GH:WorkOrdersTradegood(109135) end,
											desc = function() return GH:WorkOrdersTradegoodTooltip(109135) end,
											width = "full",
											get = function() return GH.db.profile.workorderstradegood[109135] end,
											set = function(info, value) GH.db.profile.workorderstradegood[109135] = value end,
										},
										tradegood17 = {
											order = 16,
											type = "toggle",
											name = function() return GH:WorkOrdersTradegood(109136) end,
											desc = function() return GH:WorkOrdersTradegoodTooltip(109136) end,
											width = "full",
											get = function() return GH.db.profile.workorderstradegood[109136] end,
											set = function(info, value) GH.db.profile.workorderstradegood[109136] = value end,
										},
										]]
										tradegood18 = {
											order = 17,
											type = "toggle",
											name = function() return GH:WorkOrdersTradegood(109137) end,
											desc = function() return GH:WorkOrdersTradegoodTooltip(109137) end,
											width = "full",
											get = function() return GH.db.profile.workorderstradegood[109137] end,
											set = function(info, value) GH.db.profile.workorderstradegood[109137] = value end,
										},
										--[[
										tradegood19 = {
											order = 18,
											type = "toggle",
											name = function() return GH:WorkOrdersTradegood(109138) end,
											desc = function() return GH:WorkOrdersTradegoodTooltip(109138) end,
											width = "full",
											get = function() return GH.db.profile.workorderstradegood[109138] end,
											set = function(info, value) GH.db.profile.workorderstradegood[109138] = value end,
										},
										tradegood20 = {
											order = 19,
											type = "toggle",
											name = function() return GH:WorkOrdersTradegood(109139) end,
											desc = function() return GH:WorkOrdersTradegoodTooltip(109139) end,
											width = "full",
											get = function() return GH.db.profile.workorderstradegood[109139] end,
											set = function(info, value) GH.db.profile.workorderstradegood[109139] = value end,
										},
										tradegood21 = {
											order = 20,
											type = "toggle",
											name = function() return GH:WorkOrdersTradegood(109140) end,
											desc = function() return GH:WorkOrdersTradegoodTooltip(109140) end,
											width = "full",
											get = function() return GH.db.profile.workorderstradegood[109140] end,
											set = function(info, value) GH.db.profile.workorderstradegood[109140] = value end,
										},
										tradegood22 = {
											order = 21,
											type = "toggle",
											name = function() return GH:WorkOrdersTradegood(109141) end,
											desc = function() return GH:WorkOrdersTradegoodTooltip(109141) end,
											width = "full",
											get = function() return GH.db.profile.workorderstradegood[109141] end,
											set = function(info, value) GH.db.profile.workorderstradegood[109141] = value end,
										},
										tradegood23 = {
											order = 22,
											type = "toggle",
											name = function() return GH:WorkOrdersTradegood(109142) end,
											desc = function() return GH:WorkOrdersTradegoodTooltip(109142) end,
											width = "full",
											get = function() return GH.db.profile.workorderstradegood[109142] end,
											set = function(info, value) GH.db.profile.workorderstradegood[109142] = value end,
										},
										tradegood24 = {
											order = 23,
											type = "toggle",
											name = function() return GH:WorkOrdersTradegood(109143) end,
											desc = function() return GH:WorkOrdersTradegoodTooltip(109143) end,
											width = "full",
											get = function() return GH.db.profile.workorderstradegood[109143] end,
											set = function(info, value) GH.db.profile.workorderstradegood[109143] = value end,
										},
										tradegood25 = {
											order = 24,
											type = "toggle",
											name = function() return GH:WorkOrdersTradegood(109144) end,
											desc = function() return GH:WorkOrdersTradegoodTooltip(109144) end,
											width = "full",
											get = function() return GH.db.profile.workorderstradegood[109144] end,
											set = function(info, value) GH.db.profile.workorderstradegood[109144] = value end,
										},
										]]
										
									},
								},
							},
						},
					},
				},
			},
		}
	},
}


function GH:RegisterButtons()
	--load saved herb list
	local herborder = GH.interfacePanel.args.scribetab.args.scribesupport.args.herborder.args
	for i=1,10 do
		if herborder["herb" .. i] and GH.db.profile["herb" .. i] then
			herborder["herb" .. i].name=GH.db.profile["herb" .. i]
		end
	end

	-- register buttons also for right click
	--if _G["AceGUI30Button1Text"] then table.foreach(_G["AceGUI30Button1Text"], print) end 
	--for k, v in pairs(_G) do if string.find(k, "Ace") and string.find(k, "Ace")==1 then print(k) end end
	for i=1,10 do
		if _G["AceGUI30Button" .. i ] then
			_G["AceGUI30Button" .. i ]:RegisterForClicks("LeftButtonUp", "RightButtonUp")
			_G["AceGUI30Button" .. i ]:SetWidth(50)
			_G["AceGUI30Button" .. i ]:SetHeight(50)
			--Icon
			local id = tonumber(_G["AceGUI30Button" .. i ]:GetText())
				local icon = _G["AceGUI30Button" .. i ].icon or _G["AceGUI30Button" .. i ]:CreateTexture(nil, "OVERLAY")
				icon:SetAllPoints(true)
				icon:SetTexture(GetItemIcon(id))
				_G["AceGUI30Button" .. i ].icon = icon
			
				--Tooltip
				_G["AceGUI30Button" .. i ]:SetScript("OnEnter", function(self)
					GameTooltip:SetOwner(self,"ANCHOR_TOP");
					GameTooltip:SetItemByID(id);
					GameTooltip:SetClampedToScreen(true);
					GameTooltip:AddLine("\n|r|cFFFF7700<GarrisonHelper>|r|cFFFFFFFF:",  1,1,0.5, true)
					GameTooltip:AddLine("<left click> to raise priority\n<right click> to lower the priority", 1, 1, 1, true)
					GameTooltip:Show();
				end);
				_G["AceGUI30Button" .. i ]:SetScript("OnLeave", function(self)
					GameTooltip:Hide();
				end);
		end
	end
	-- make makrotext selectable
	--[[
	if _G["AceGUI30Button1"] then
		local p = _G["AceGUI30Button1"]:GetParent()
		if p then
			local children = { p:GetChildren() };
			if #children>0 then
				for _, child in ipairs(children) do
					if child and child.obj and child.obj.type and child.obj.type=="InlineGroup" then
						while child:GetChildren() do
							child = child:GetChildren()
						end
						
						local macro = child:GetRegions():GetText()
						child:GetRegions():Hide()
						
						local text = child.text or child:CreateTexture(nil, "OVERLAY")
						text:SetAllPoints(true)
						child.text = text
						local title = child.title or CreateFrame("Frame", nil, child)
						title:SetAllPoints(text)
						child.title = title
						local titletext = child.titletext or title:CreateFontString(nil, "OVERLAY", "GameFontNormal")
						titletext:SetPoint("TOPLEFT", text, "TOPLEFT", 0, 5)
						titletext:SetJustifyH("LEFT")
						titletext:SetText(macro)
						child.titletext = titletext
						
					end
				end
			end
			
		end
	end
	]]
end

function GH:reorderHerbs(arg1, arg2)
	--print(select(2,GetItemInfo(tonumber(arg1.option.name))) .. "   " .. tostring(arg1) .. "  "  .. tostring(arg2))
	-- GH.interfacePanel.args.scribetab.args.scribesupport.args.herborder.args.herb1
	
	local herb = GH.interfacePanel
	local herborder
	for i=1,10 do
		if arg1[i] then
			herborder = herb.args -- parent
			herb = herb.args[arg1[i]]
		else
			break
		end
	end
	--herb.name = "\124T"..GetItemIcon(109128) ..":24\124t" .. "XXXXXXX"
	--[[
	for i=1,10 do
		if herborder["herb" .. i] then
			print(select(2,GetItemInfo(tonumber(herborder["herb" .. i].name))) .. "   order: " .. herborder["herb" .. i].order)		
		end
	end
	]]
	for i=1,10 do
		if herborder["herb" .. i] then
			if arg2=="LeftButton" then
				if herborder["herb" .. i].order == herb.order-1 then
					local n = herborder["herb" .. i].name
					herborder["herb" .. i].name = herb.name
					herb.name = n
					break
				end
			elseif arg2=="RightButton" then
				if herborder["herb" .. i].order == herb.order+1 then
					local n = herborder["herb" .. i].name
					herborder["herb" .. i].name = herb.name
					herb.name = n
					break
				end
			end
		else
			break
		end
	end
	--[[
	for i=1,10 do
		if herborder["herb" .. i] then
			print(">>>" .. select(2,GetItemInfo(tonumber(herborder["herb" .. i].name))) .. "   order: " .. herborder["herb" .. i].order)		
		end
	end
	]]
	--table.foreach(herborder, print)
	
	-- save order
	for i=1,10 do
		if herborder["herb" .. i] then
			--print(">>>" .. select(2,GetItemInfo(tonumber(herborder["herb" .. i].name))) .. "   order: " .. herborder["herb" .. i].order)	
			GH.db.profile["herb" .. i]=herborder["herb" .. i].name
		end
	end
end

--Setup options
function GH:CreateOptions()
	local mainPanel = CreateFrame("Frame", "GarrisonHelperOptionsMain")
	local title = mainPanel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	local version = mainPanel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	local author = mainPanel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	title:SetFormattedText("%s", "GarrisonHelper")
	title:SetPoint("CENTER", mainPanel, "CENTER", 0, 170)
	version:SetFormattedText("%s %s", _G.GAME_VERSION_LABEL, GetAddOnMetadata("GarrisonHelper", "Version"))
	version:SetPoint("CENTER", mainPanel, "CENTER", 0, 130)
	author:SetFormattedText("%s: Ianeel", "Author")
	author:SetPoint("CENTER", mainPanel, "CENTER", 0, 100)
	mainPanel.name = "GarrisonHelper"
	InterfaceOptions_AddCategory(mainPanel)
	AceConfig:RegisterOptionsTable("GarrisonHelperOptionsInterface", GH.interfacePanel)
	GH.InterfaceFrame = AceConfigDialog:AddToBlizOptions("GarrisonHelperOptionsInterface", "Configuration", "GarrisonHelper")
	GH.InterfaceFrame.default = function() resetinterface() end
	--AceConfigDialog:AddToBlizOptions("GarrisonHelperOptionsProfiles", "Profiles", "GarrisonHelper")
end

