local GH = GarrisonHelper
-- Frame and Events
local GarrisonHelper_Events = CreateFrame("Frame");
local events = {};

--[[
Name		Ore		Dust	Fur		Herbs	Hide	Meat	Flesh
Yula		4*		5		4*		8		10		5		8
Talgaiir 	10		10		5		5		4*		8		4*
Portanuus	6		6		6		6		6		6		6

Krixel		6		8		10		10		8		4*		5
Pyxni		8		4*		8		4*		8		10		10

Surehide	4*		5		4*		8		10		5		8
Ribchewer	10		10		5		5		4*		8		4*
Tai'tasi	6		6		6		6		6		6		6
]]--

GH.npcMessages = {
	[86779] = {"Krixel", "Meat", {109131,109132,109133,109134,109135,109136,}},
	[87200] = {"Krixel", "Meat", {109131,109132,109133,109134,109135,109136,}},
	[86778] = {"Pyxni", "Dust & Herbs", {109693,109124,109125,109126,109127,109128,109129,}},
	[87201] = {"Pyxni", "Dust & Herbs", {109693,109124,109125,109126,109127,109128,109129,}},
	[86776] = {"Ribchewer", "Leather & Fish",{110609,109137,109138,109139,109140,109141,109142,109143,109144,}},
	[87203] = {"Talgaiir", "Leather & Fish",{110609,109137,109138,109139,109140,109141,109142,109143,109144,}},
	[86777] = {"Surehide", "Ore & Cloth",{109118,109119,111557,}},
	[87202] = {"Yula", "Ore & Cloth",{109118,109119,111557,}},
	[86683] = {"Tai'tasi", "-", {}},
	[87204] = {"Portanuus", "-", {}},
}

function GH:isTradingPostEnabled()
	if type(GH.db.profile.tradingpostsupport)==nil then GH.db.profile.tradingpostsupport=true end
	return GH.db.profile.tradingpostsupport
end

function events.UPDATE_MOUSEOVER_UNIT()
	if GH:isTradingPostEnabled() then
		for id, arr in pairs(GH.npcMessages) do
			if GH:isNPC(id,"mouseover") then
				local timeout = 300 -- 300s (5min) between same print outs
				if not arr[4] or arr[4]+timeout < time() then
					local p = "On sale: "
					if #arr[3]==0 then
						p = p .. " nothing"
					else
						GH.db.profile.tradingpostoption = GH.db.profile.tradingpostoption or "icons"
						if GH.db.profile.tradingpostoption == "icons" then
							for i=1,#arr[3] do
								p = p .. "\124T" .. select(10,GetItemInfo(arr[3][i]))  ..":24\124t "
							end
						elseif GH.db.profile.tradingpostoption == "short" then
							p = p .. arr[2]
						elseif GH.db.profile.tradingpostoption == "links" then
							for i=1,#arr[3] do
								p = p .. select(2,GetItemInfo(arr[3][i])) .. " "
							end
						end
					
						
					end
					GH:print(p);
					arr[4] = time();
				end
				break
			end
		end
	end
end

-- register event listener
GarrisonHelper_Events:SetScript("OnEvent", function(self, event, ...) events[event](self, event, ...); end);
for event, func in pairs(events) do GarrisonHelper_Events:RegisterEvent(event); end


--[[
	Needed, because if cache is empty, this information have to be retrieved from server.
]]
function GH:PreLoadTradingPostItemInfos()
	for id, arr in pairs(GH.npcMessages) do
		for i=1,#arr[3] do
			GetItemInfo(arr[3][i])
		end
	end
end
GH:PreLoadTradingPostItemInfos() -- TODO move this to an event like addon loaded